from __future__ import annotations
from typing import Any, Protocol, runtime_checkable
from com.sun.star.lang import XEventListener

@runtime_checkable
class XDockableWindowListener(XEventListener, Protocol):
    def startDocking(self, e: DockingEvent) -> None: ...
    def docking(self, e: DockingEvent) -> DockingData: ...
    def endDocking(self, e: EndDockingEvent) -> None: ...
    def prepareToggleFloatingMode(self, e: EventObject) -> bool: ...
    def toggleFloatingMode(self, e: EventObject) -> None: ...
    def closed(self, e: EventObject) -> None: ...
    def endPopupMode(self, e: EndPopupModeEvent) -> None: ...
